//
// File:   f1.cc
// Author: cteam029
//
// Created on October 19, 2013, 10:26 AM
//

#include <cstdlib>
#include <iostream>
#include <vector>
#include <map>
#include <climits>
#include <sstream>
#include <string>
#include <list>

using namespace std;

struct Node{
    vector<int> off;
    int force;
    Node(int force):force(force){};
    int Count(map <int, Node*> &all){
        int res = 0;
        for(vector<int>::iterator it = off.begin(); it != off.end(); ++it){
            res += all[*it]->Count(all);
        }
        if(off.empty() || force < res){
            return force;
        }else{
            return res;
        }
        return force;
    }
};

struct Rec{
    Rec(int start, int  end, int  force):start(start), end(end), force(force){};
    int start, end, force;
    int what(int i){
        if(start == i){
            return end;
        }else if(end == i){
            return start;
        }
        return -1;
    }
};
//
//
//
int main() {
    int count, central, start, end, force;
    Node *root = NULL;
    map <int, Node*> all;
    while(cin >> count >> central){
        
        //---------------------
        vector <Rec*> records;
        vector <Rec*> r;
        list <int> que;
        stringstream ss;
        que.push_back(central);
        for(int i = 0; i < count; i++){
            cin >> start >> end >> force;
            records.push_back(new Rec(start, end, force));
        }
        while(!que.empty()){
            for(vector <Rec*>::iterator it = records.begin(); it != records.end(); ++it){
                if((*it)->what(*que.begin()) != -1){
                    que.push_back((*it)->what(*que.begin()));
                    r.push_back(*it);
                    records.erase(it);
                }
            }
            que.pop_front();
        }
        for(vector <Rec*>::iterator it = r.begin(); it != r.end(); ++it){
            ss << (*it)->start << " " << (*it)->end << " " << (*it)->force << endl;
        }
        
        
        //---------------------
        
        root = new Node(INT_MAX);
        all.insert(pair<int, Node*>(central, root));
        count--;
        for(int i = 0; i < count; i++){
            ss >> start >> end >> force;
            map<int, Node*>::iterator it = all.find(start);
            if(it == all.end()){
                Node* s = new Node(force);
                all.insert(pair<int, Node*>(start, s));
                all[end]->off.push_back(start);
            }
            map<int, Node*>::iterator is = all.find(end);
            if(is == all.end()){
                Node* s = new Node(force);
                all.insert(pair<int, Node*>(end, s));
                all[start]->off.push_back(end);
            }
        }
        int res;
        res = root->Count(all);
        cout << res << endl;
        for(map<int, Node*>::iterator it = all.begin(); it != all.end(); ++it){
            delete (*it).second;
        }
        root = NULL;
        all.clear();
    }
    return 0;
}

